#ifndef GUARD_Det
#define GUARD_Det

#include <map>
#include <vector>
#include <string>
#include "dg_node.h"
#include <unordered_set>

/*
        reads a list of mftr to mrlv mapping, build DGs for each new 
        mftr and mrlv, connect them and store them in name2node
*/
std::map<std::string, DG_Node> createDGfromCSV(const char* fn);

/*
	lookup orgiznation from an input MAC address via API of macaddress.io
*/
std::string maclookup(const std::string& mac_addr, const std::string& apikey);

/*
        Look up DG_Node in DG (name2node) with orgnaization name; for a hit, return pointer
        to the macthing DG_Node, for a miss, return NULL pointer
*/
const DG_Node* findNodeFromName(std::string&, const std::map<std::string, DG_Node>&);

/*
        output a short list of potential mftr DG_Node* for the input DG_Node
*/
std::vector<const DG_Node*> findPoMftrsFromNode(const DG_Node& inode);

const std::unordered_set<std::string> other_multicast_MACs ({"01:00:0c:cc:cc:cc","01:00:0c:cc:cc:cd","01:80:c2:00:00:00","01:80:c2:00:00:03","01:80:c2:00:00:0e","01:80:c2:00:00:08","01:80:c2:00:00:01","01:80:c2:00:00:02","01:80:c2:00:00:30","01:80:c2:00:00:31","01:80:c2:00:00:32","01:80:c2:00:00:33","01:80:c2:00:00:34","01:80:c2:00:00:35","01:80:c2:00:00:36","01:80:c2:00:00:37","01:80:c2:00:00:38","01:80:c2:00:00:39","01:80:c2:00:00:3a","01:80:c2:00:00:3b","01:80:c2:00:00:3c","01:80:c2:00:00:3d","01:80:c2:00:00:3e","01:80:c2:00:00:3f","01:1b:19:00:00:00","01:1b:19:00:00:0e","aa:aa:03:00:00:00"}); //https://embeddist.wordpress.com/2015/10/07/well-known-ethernet-multicast-address/, https://wiki.wireshark.org/LinkLayerDiscoveryProtocol



#endif //GUARD_Det
