#ifndef GUARD_DG_Node_H
#define GUARD_DG_Node_H

#include <vector>
#include <string>

/*
 DG node for storing known manufacuters and manufacuter-realtives and their mapping,
 used for the IoT detection part of IoTSED
*/

class DG_Node {
public:
 DG_Node(const std::string& n, bool t):Name(n),Type(t){}
 DG_Node(const char* n, bool t):Name(n),Type(t){}
 bool isMftr() const { return Type;}
 void changeType(bool t){Type=t;}
 const std::string& getName() const { return Name;}
 void addNextNode(const DG_Node& newNode){ Nexts.push_back(&newNode); }
 const std::vector<const DG_Node*>& getNexts() const { return Nexts;}

private:
 std::string Name;
 bool Type; // true for manufater;  false for manufacuter-relative
 std::vector<const DG_Node*> Nexts;
};


#endif //GUARD_DG_Node_H
