#ifndef GUARD_Svr_H
#define GUARD_Svr_H

#include <string>
#include <map>
#include <unordered_set>
#include <sys/time.h>

/*
        Svr class storing relavent information of every distinct server names we've seen 
*/

class Dev;

class Svr {
public:
Svr(const std::string& n, bool type):sname(n),abn(type){}
void addIP(std::string& IP){ IPs.insert(IP); }
void addCname(std::string& cn){ cnames.insert(cn); }

std::string sname; //the server name that IoT device first query 
std::unordered_set<std::string> IPs; //IPs for sname found in A recrod
std::unordered_set<std::string> cnames; // cnames for sname found in CNAME record
std::map<Dev*, bool> dev2svr_cls; // for every device talk to this server, is this server an IoT device? True for yes, False for no.
std::map<Dev*, time_t> dev2first_access_time; // for every device talk to this server,this is timestamp of the first packet each device DNS query/ talk to this server
std::map<Dev*, double> dev2rounds; // for every device talk to this server, this is number of round this server is learnt
bool abn; //is this a abn server (i.e. accessed by server name?)



};

#endif //GUARD_Svr_H

